// ControlBoxDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ControlBox.h"
#include "ControlBoxDlg.h"
#include <TLHELP32.H>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

namespace PK
{
	void KillProcess(const char *EXEName)
	{
		HANDLE snapshot_handle = ::CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
		if (INVALID_HANDLE_VALUE != snapshot_handle)
		{
			PROCESSENTRY32 pe;
			if (Process32First(snapshot_handle, &pe))
			{
				do
				{
					//TRACE("KillProcess() PID = %04u, FileName = %s\n", pe.th32ProcessID, pe.szExeFile);
					if (!_tcscmp(pe.szExeFile, (LPCTSTR)EXEName))
					{
						HANDLE process_handle = OpenProcess(PROCESS_TERMINATE, FALSE, pe.th32ProcessID);
						if (INVALID_HANDLE_VALUE != process_handle)
						{
							TRACE("μ !\n");
							TerminateProcess(process_handle, 0);
							CloseHandle(process_handle);
						}
					}
				} while (Process32Next(snapshot_handle, &pe));
			}
			
			CloseHandle(snapshot_handle);
			snapshot_handle = INVALID_HANDLE_VALUE;
		} 
	}
}

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlBoxDlg dialog

CControlBoxDlg::CControlBoxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CControlBoxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CControlBoxDlg)
	m_str = _T("");
	m_ClientLevel = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CControlBoxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CControlBoxDlg)
	DDX_Control(pDX, IDC_LIST2, m_ClientCtrl);
	DDX_Control(pDX, IDC_LIST1, m_ctrl);
	DDX_LBString(pDX, IDC_LIST1, m_str);
	DDX_LBString(pDX, IDC_LIST2, m_ClientLevel);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CControlBoxDlg, CDialog)
	//{{AFX_MSG_MAP(CControlBoxDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_KILL, OnKill)
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclk)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlBoxDlg message handlers

BOOL CControlBoxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	CString strProduct[] = {_T("naejo_cif_15fps.mov"), _T("naejo_cif_30fps.mov"),
	_T("naejo_cif_60fps.mov")};
	CString NetLev[] = {_T("A"), _T("B"), _T("C"), _T("D")};

	for(int i=0; i<sizeof(strProduct)/sizeof(CString); i++)
		m_ctrl.AddString(strProduct[i]);
	for(int j=0; j<sizeof(NetLev)/sizeof(CString); j++)
		m_ClientCtrl.AddString(NetLev[j]);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CControlBoxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CControlBoxDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CControlBoxDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CControlBoxDlg::OnConnect() 
{
	if(m_Socket.Create() == FALSE)
	{
		AfxMessageBox("  ");
		return;
	}
	
	if(m_Socket.Connect("", 6565) == FALSE)
		AfxMessageBox(" ");
	else
		AfxMessageBox(" ");	
}

void CControlBoxDlg::OnPlay() 
{
	CString temp;
	temp =  "naejo_cif_15fps.mov";
	m_cont = "C:\\Program Files\\VideoLAN\\VLC\\vlc.exe rtsp:///";
	temp = m_cont + temp;
	//AfxMessageBox(temp);
	WinExec(temp, SW_SHOW);
}


void CControlBoxDlg::OnKill() 
{
	m_cont = "vlc.exe";
	PK::KillProcess(m_cont);
}

void CControlBoxDlg::OnDblclk()
{
	int nSel = m_ctrl.GetCurSel();
    m_cont = "C:\\Program Files\\VideoLAN\\VLC\\vlc.exe rtsp:///";

	if(nSel >= 0)
	{
		UpdateData(TRUE);
		m_cont += m_str;
		WinExec(m_cont, SW_SHOW);
	}
}
